From 1beccb4ce2cfea43eb1999c63b9280e23b7d4833 Mon Sep 17 00:00:00 2001
From: Thomas NOEL <tnoel@entrouvert.com>
Date: Mon, 29 Apr 2019 19:54:52 +0200
Subject: [PATCH] use -10000px indentation to hide texts (#32680)

---
 static/alpes-maritimes-2018/_custom.scss         | 2 +-
 static/amiens/_custom.scss                       | 2 +-
 static/auch/_custom.scss                         | 2 +-
 static/bron/_custom.scss                         | 2 +-
 static/clermont-metropole/_custom.scss           | 2 +-
 static/clisson-sevre-et-maine-agglo/_custom.scss | 2 +-
 static/clisson/_custom.scss                      | 2 +-
 static/dardilly/_custom.scss                     | 2 +-
 static/dreux/_custom.scss                        | 2 +-
 static/fontenay-sous-bois-2017/_custom.scss      | 4 ++--
 static/gorges/_custom.scss                       | 4 ++--
 static/grandlyon-sau/_custom.scss                | 2 +-
 static/grandlyon/_custom.scss                    | 4 ++--
 static/groupe-up/_custom.scss                    | 2 +-
 static/haute-goulaine/_custom.scss               | 4 ++--
 static/la-reunion/_custom.scss                   | 2 +-
 static/meudon/_custom.scss                       | 2 +-
 static/meyzieu-2018/_custom.scss                 | 2 +-
 static/meyzieu/_custom.scss                      | 2 +-
 static/montpellier/_custom.scss                  | 2 +-
 static/nanterre/_custom.scss                     | 2 +-
 static/saint-lo-agglo/_custom.scss               | 2 +-
 static/seine-et-marne-apa/_custom.scss           | 6 +++---
 static/sicoval/_custom.scss                      | 2 +-
 static/thonon-agglomeration/_custom.scss         | 2 +-
 static/toulouse/_custom.scss                     | 4 ++--
 static/tours-metropole/_custom.scss              | 4 ++--
 static/tours/_custom.scss                        | 2 +-
 static/villejuif/_custom.scss                    | 2 +-
 29 files changed, 37 insertions(+), 37 deletions(-)

diff --git a/static/alpes-maritimes-2018/_custom.scss b/static/alpes-maritimes-2018/_custom.scss
index bcd83cee..0a54d360 100644
--- a/static/alpes-maritimes-2018/_custom.scss
+++ b/static/alpes-maritimes-2018/_custom.scss
@@ -55,7 +55,7 @@ div#main-content-wrapper {
 	span {
 		a {
 			@media screen and (max-width: $mobile-limit) {
-				text-indent: -9999px;
+				text-indent: -10000px;
 			}
 			&:first-child {
 				&::before {
diff --git a/static/amiens/_custom.scss b/static/amiens/_custom.scss
index 10a0f0fe..84ea0684 100644
--- a/static/amiens/_custom.scss
+++ b/static/amiens/_custom.scss
@@ -33,7 +33,7 @@ h1#logo a {
 	padding-left: 200px;
 	color: $font-color;
 	overflow: hidden;
-	text-indent: -2000px;
+	text-indent: -10000px;
 }
 
 div#main-content-wrapper {
diff --git a/static/auch/_custom.scss b/static/auch/_custom.scss
index 0dc4c23f..f44c9566 100644
--- a/static/auch/_custom.scss
+++ b/static/auch/_custom.scss
@@ -30,5 +30,5 @@ h1#logo a {
 	background-size: contain;
 	display: block;
 	height: 180px;
-	text-indent: -9999px;
+	text-indent: -10000px;
 }
diff --git a/static/bron/_custom.scss b/static/bron/_custom.scss
index 9c08c225..08c2b1c4 100644
--- a/static/bron/_custom.scss
+++ b/static/bron/_custom.scss
@@ -10,7 +10,7 @@ h1#logo a {
 	color: white;
 	@media screen and (max-width: $mobile-limit) {
 		overflow: hidden;
-		text-indent: -2000px;
+		text-indent: -10000px;
 	}
 }
 
diff --git a/static/clermont-metropole/_custom.scss b/static/clermont-metropole/_custom.scss
index 2f4209b9..0f2de7c5 100644
--- a/static/clermont-metropole/_custom.scss
+++ b/static/clermont-metropole/_custom.scss
@@ -7,7 +7,7 @@ h1#logo {
 		background-repeat: no-repeat;
 		background-position: 5% bottom;
 		display: block;
-		text-indent: -9999px;
+		text-indent: -10000px;
 		height: 50px;
 		@media screen and (max-width: $mobile-limit) {
 			background-position: center center;
diff --git a/static/clisson-sevre-et-maine-agglo/_custom.scss b/static/clisson-sevre-et-maine-agglo/_custom.scss
index 25f2349e..d4ea5796 100644
--- a/static/clisson-sevre-et-maine-agglo/_custom.scss
+++ b/static/clisson-sevre-et-maine-agglo/_custom.scss
@@ -26,7 +26,7 @@ h1#logo a {
 		width: 100%;
 		padding-left: 0;
 		overflow: hidden;
-		text-indent: -2000px;
+		text-indent: -10000px;
 	}
 }
 
diff --git a/static/clisson/_custom.scss b/static/clisson/_custom.scss
index ae500cbb..aabb477d 100644
--- a/static/clisson/_custom.scss
+++ b/static/clisson/_custom.scss
@@ -16,7 +16,7 @@ h1#logo a {
 	color: $title-color;
 	@media screen and (max-width: $mobile-limit) {
 		overflow: hidden;
-		text-indent: -2000px;
+		text-indent: -10000px;
 	}
 }
 
diff --git a/static/dardilly/_custom.scss b/static/dardilly/_custom.scss
index 019ec4dc..8a53728e 100644
--- a/static/dardilly/_custom.scss
+++ b/static/dardilly/_custom.scss
@@ -17,7 +17,7 @@ h1#logo a {
 	color: white;
 	display: block;
 	@media screen and (max-width: $mobile-limit) {
-		text-indent: -2000px;
+		text-indent: -10000px;
 	}
 }
 
diff --git a/static/dreux/_custom.scss b/static/dreux/_custom.scss
index 331de580..631952ad 100644
--- a/static/dreux/_custom.scss
+++ b/static/dreux/_custom.scss
@@ -13,7 +13,7 @@ h1#logo a {
 	background-color: transparent;
 	height: 215px;
 	display: block;
-	text-indent: -9999px;
+	text-indent: -10000px;
 }
 
 div#header-wrapper {
diff --git a/static/fontenay-sous-bois-2017/_custom.scss b/static/fontenay-sous-bois-2017/_custom.scss
index 52677853..a96555b9 100644
--- a/static/fontenay-sous-bois-2017/_custom.scss
+++ b/static/fontenay-sous-bois-2017/_custom.scss
@@ -44,7 +44,7 @@ h1#logo a {
     min-height: 70px;
     z-index: 200;
     width: 215px;
-    text-indent: -9999px;
+    text-indent: -10000px;
     overflow: hidden;
 }
 
@@ -65,7 +65,7 @@ div#nav > ul > li:first-child a {
     background: $primary-color url(img/home.png) no-repeat center 0px;
     width: 45px;
     color: $nav-color;
-    text-indent: -2000px;
+    text-indent: -10000px;
     padding: 0;
     @media screen and (max-width: $mobile-limit) {
         display: none;
diff --git a/static/gorges/_custom.scss b/static/gorges/_custom.scss
index ade79d22..4eea8e34 100644
--- a/static/gorges/_custom.scss
+++ b/static/gorges/_custom.scss
@@ -12,10 +12,10 @@ h1#logo a {
 	line-height: 80px;
 	padding-left: 250px;
 	color: $title-color;
-        text-indent: -9999px;
+        text-indent: -10000px;
 	@media screen and (max-width: $mobile-limit) {
 		overflow: hidden;
-		text-indent: -2000px;
+		text-indent: -10000px;
 	}
 }
 
diff --git a/static/grandlyon-sau/_custom.scss b/static/grandlyon-sau/_custom.scss
index ef52d3cc..6f61835a 100644
--- a/static/grandlyon-sau/_custom.scss
+++ b/static/grandlyon-sau/_custom.scss
@@ -246,7 +246,7 @@ div.cell > div {
 				background-size: contain;
 				padding-left: 6em;
 				@media screen and (max-width: $mobile-limit) {
-					text-indent: -9999px;
+					text-indent: -10000px;
 				}
 				&:hover {
 					color: $link-color;
diff --git a/static/grandlyon/_custom.scss b/static/grandlyon/_custom.scss
index eea56c56..928d0879 100644
--- a/static/grandlyon/_custom.scss
+++ b/static/grandlyon/_custom.scss
@@ -18,14 +18,14 @@ h1#logo {
 		width: 100%;
 		text-indent: 140px;
 		@media screen and (max-width: $mobile-limit) {
-			text-indent: -1000px;
+			text-indent: -10000px;
 			width: auto;
 		}
 	}
 	&.has-logo {
 		a {
 			background-image: url(/assets/header:logo);
-			text-indent: -1000px;
+			text-indent: -10000px;
 		}
 	}
 }
diff --git a/static/groupe-up/_custom.scss b/static/groupe-up/_custom.scss
index 04c8d51b..349c4b84 100644
--- a/static/groupe-up/_custom.scss
+++ b/static/groupe-up/_custom.scss
@@ -125,7 +125,7 @@ nav {
 	}
 	a.logout {
 		display: inline-block;
-		text-indent: -2000px;
+		text-indent: -10000px;
 		margin-right: 0;
 		&::after {
 			content: "\f05c";  // fa-times-circle-o
diff --git a/static/haute-goulaine/_custom.scss b/static/haute-goulaine/_custom.scss
index 2e3268cb..6b962411 100644
--- a/static/haute-goulaine/_custom.scss
+++ b/static/haute-goulaine/_custom.scss
@@ -15,7 +15,7 @@ div#header h1 {
 		height: 155px;
 	}
 	a {
-		text-indent: -9999px;
+		text-indent: -10000px;
 	}
 }
 
@@ -24,7 +24,7 @@ div#header h1 a {
 	padding-left: 180px;
 	display: inline-block;
 	@media screen and (max-width: $mobile-limit) {
-		text-indent: -2000px;
+		text-indent: -10000px;
 		overflow: hidden;
 	}
 }
diff --git a/static/la-reunion/_custom.scss b/static/la-reunion/_custom.scss
index bd5b2395..739b31a4 100644
--- a/static/la-reunion/_custom.scss
+++ b/static/la-reunion/_custom.scss
@@ -13,7 +13,7 @@ div#header {
 	font-weight: normal;
 	@media screen and (max-width: $mobile-limit) {
 		overflow: hidden;
-		text-indent: -2000px;
+		text-indent: -10000px;
 	}
 }
 
diff --git a/static/meudon/_custom.scss b/static/meudon/_custom.scss
index a6dde5d8..ac1ab49a 100644
--- a/static/meudon/_custom.scss
+++ b/static/meudon/_custom.scss
@@ -159,7 +159,7 @@ div.buttons.submit {
 
 	#header #top #logo a {
 		padding-left: 0;
-		text-indent: -1000px;
+		text-indent: -10000px;
 	}
 
 	div#nav {
diff --git a/static/meyzieu-2018/_custom.scss b/static/meyzieu-2018/_custom.scss
index 12a19ee5..2ffabd88 100644
--- a/static/meyzieu-2018/_custom.scss
+++ b/static/meyzieu-2018/_custom.scss
@@ -13,7 +13,7 @@
 		background-size: 75% auto;
 	}
 	h1#logo {
-		text-indent: -999999px;
+		text-indent: -10000px;
 	}
 }
 
diff --git a/static/meyzieu/_custom.scss b/static/meyzieu/_custom.scss
index 0f87b476..f2f61b23 100644
--- a/static/meyzieu/_custom.scss
+++ b/static/meyzieu/_custom.scss
@@ -195,7 +195,7 @@ a {
        float: right;
        margin: 50px 0 0 0;
        a {
-           text-indent: -9999em;
+           text-indent: -10000px;
            display: block;
            overflow: hidden;
            background: url(images/back-top.png) left top no-repeat;
diff --git a/static/montpellier/_custom.scss b/static/montpellier/_custom.scss
index 418400e6..ba85de14 100644
--- a/static/montpellier/_custom.scss
+++ b/static/montpellier/_custom.scss
@@ -58,7 +58,7 @@ div#top {
 div#top > a {
   padding-top: 30px;
   display: block;
-  text-indent: -1000px;
+  text-indent: -10000px;
   padding-bottom: 140px;
 }
 
diff --git a/static/nanterre/_custom.scss b/static/nanterre/_custom.scss
index 6fff430d..ca953651 100644
--- a/static/nanterre/_custom.scss
+++ b/static/nanterre/_custom.scss
@@ -16,7 +16,7 @@ h1#logo {
 }
 
 h1#logo a {
-	text-indent: -1000px;
+	text-indent: -10000px;
 	display: block;
 	color: $primary-color;
 	background: url(img/logo_nanterre.png) top left no-repeat;
diff --git a/static/saint-lo-agglo/_custom.scss b/static/saint-lo-agglo/_custom.scss
index 890ca21b..3663a7ff 100644
--- a/static/saint-lo-agglo/_custom.scss
+++ b/static/saint-lo-agglo/_custom.scss
@@ -27,7 +27,7 @@ div#header h1#logo {
 	position: absolute;
 	a {
 		background: url(img/saint-lo-agglo.png) bottom left no-repeat;
-		text-indent: -3000px;
+		text-indent: -10000px;
 		display: block;
 		width: 271px;
 		height: 138px;
diff --git a/static/seine-et-marne-apa/_custom.scss b/static/seine-et-marne-apa/_custom.scss
index edf4b3b0..9a0d2a94 100644
--- a/static/seine-et-marne-apa/_custom.scss
+++ b/static/seine-et-marne-apa/_custom.scss
@@ -47,7 +47,7 @@ div#header::after {
 div#header h1 a {
 	background: url(img/portail.png) top left no-repeat;
 	display: inline-block;
-	text-indent: -2000px;
+	text-indent: -10000px;
 	width: 259px;
 	height: 44px;
 	padding: 0;
@@ -93,7 +93,7 @@ body.anonymous-user {
 	div#header h1 a {
 		background: url(img/bienvenue.png) top left no-repeat;
 		display: inline-block;
-		text-indent: -2000px;
+		text-indent: -10000px;
 		width: 733px;
 		height: 144px;
 		padding: 0;
@@ -171,7 +171,7 @@ nav {
 	}
 	a.logout {
 		display: inline-block;
-		text-indent: -2000px;
+		text-indent: -10000px;
 		margin-right: 0;
 		&::after {
 			content: "\f05c";  // fa-times-circle-o
diff --git a/static/sicoval/_custom.scss b/static/sicoval/_custom.scss
index 13c2b5a7..77b099ec 100644
--- a/static/sicoval/_custom.scss
+++ b/static/sicoval/_custom.scss
@@ -27,7 +27,7 @@ div#nav ul {
 
 	#header #top #logo a {
 		padding-left: 0;
-		text-indent: -1000px;
+		text-indent: -10000px;
 	}
 
 	div#nav {
diff --git a/static/thonon-agglomeration/_custom.scss b/static/thonon-agglomeration/_custom.scss
index 9eaaf3fa..40bd668c 100644
--- a/static/thonon-agglomeration/_custom.scss
+++ b/static/thonon-agglomeration/_custom.scss
@@ -19,7 +19,7 @@ h1#logo a {
 	background-size: contain;
 	display: block;
 	height: 68px;
-	text-indent: -9999px;
+	text-indent: -10000px;
 }
 
 @media screen and (max-width: $nav-mobile-limit) {
diff --git a/static/toulouse/_custom.scss b/static/toulouse/_custom.scss
index 6c649b9d..99245df6 100644
--- a/static/toulouse/_custom.scss
+++ b/static/toulouse/_custom.scss
@@ -232,7 +232,7 @@ footer {
 				border: 0;
 				cursor: pointer;
 				background: url(img/menu/menu-validation.png) center center no-repeat;
-				text-indent: -1000px;
+				text-indent: -10000px;
 				height: 43px;
 				width: 43px;
 			}
@@ -1504,7 +1504,7 @@ ul {
 		border: 0;
 		cursor: pointer;
 		background: url(img/menu/menu-validation.png) center center no-repeat;
-		text-indent: -1000px;
+		text-indent: -10000px;
 		height: 43px;
 		width: 43px;
 	}
diff --git a/static/tours-metropole/_custom.scss b/static/tours-metropole/_custom.scss
index 2796b402..de8887d0 100644
--- a/static/tours-metropole/_custom.scss
+++ b/static/tours-metropole/_custom.scss
@@ -33,7 +33,7 @@ body.authentic-page, body.registration-page {
 				background-position: center left;
 				background-repeat: no-repeat;
 				background-size: contain, contain;
-				text-indent: -9999px;
+				text-indent: -10000px;
 				@media screen and (max-width: $mobile-limit) {
 					background-image: url('img/logo-neutre.png');
 					background-repeat: no-repeat;;
@@ -104,7 +104,7 @@ div#header {
 			line-height: 2em;
 			font-family: 'Roboto Condensed', sans-serif;
 			@media screen and (max-width: $mobile-limit) {
-				text-indent: -9999px;
+				text-indent: -10000px;
 				background-size: contain;
 			}
 		}
diff --git a/static/tours/_custom.scss b/static/tours/_custom.scss
index be38f464..87f61e11 100644
--- a/static/tours/_custom.scss
+++ b/static/tours/_custom.scss
@@ -9,7 +9,7 @@ div#header {
 			background-size: contain;
 			display: block;
 			height: 93px;
-			text-indent: -9999px;
+			text-indent: -10000px;
 			margin: 15px 0;
 		}
 	}
diff --git a/static/villejuif/_custom.scss b/static/villejuif/_custom.scss
index dd7a15f7..21bc4975 100644
--- a/static/villejuif/_custom.scss
+++ b/static/villejuif/_custom.scss
@@ -38,7 +38,7 @@ div#header {
 	min-width: 421px;
 	color: white;
 	font-weight: normal;
-	text-indent: -9999px;
+	text-indent: -10000px;
 }
 
 div#nav {
-- 
2.20.1